<?php
class ControllerModuleNews extends Controller {
	private $error = array(); 
	
	public function index() {   
		$this->load->language('module/news');

		$this->document->title = $this->language->get('heading_title');
		
		$this->load->model('setting/setting');
				
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && ($this->validate())) {
		    if(isset($this->request->post['news_categories']))
				$this->request->post['news_categories']= implode(',',$this->request->post['news_categories']);
			else
			   $this->request->post['news_categories']='';
			$this->model_setting_setting->editSetting('news', $this->request->post);		
					
			$this->session->data['success'] = $this->language->get('text_success');
						
			$this->redirect(HTTPS_SERVER . 'index.php?route=extension/module&token=' . $this->session->data['token']);
		}
				
		$this->data['heading_title'] = $this->language->get('heading_title');

		$this->data['text_enabled'] = $this->language->get('text_enabled');
		$this->data['text_disabled'] = $this->language->get('text_disabled');
		$this->data['text_left'] = $this->language->get('text_left');
		$this->data['text_right'] = $this->language->get('text_right');
		$this->data['text_center'] = $this->language->get('text_center');
		
		$this->data['entry_position'] = $this->language->get('entry_position');
		$this->data['entry_status'] = $this->language->get('entry_status');
		$this->data['entry_sort_order'] = $this->language->get('entry_sort_order');
		$this->data['entry_category'] = $this->language->get('entry_category');
		$this->data['entry_limited'] = $this->language->get('entry_limited');
		$this->data['entry_page'] = $this->language->get('entry_page');
		$this->data['entry_col'] = $this->language->get('entry_col');

		$this->data['button_save'] = $this->language->get('button_save');
		$this->data['button_cancel'] = $this->language->get('button_cancel');

 		if (isset($this->error['warning'])) {
			$this->data['error_warning'] = $this->error['warning'];
		} else {
			$this->data['error_warning'] = '';
		}

  		$this->document->breadcrumbs = array();

   		$this->document->breadcrumbs[] = array(
       		'href'      => HTTPS_SERVER . 'index.php?route=common/home&token=' . $this->session->data['token'],
       		'text'      => $this->language->get('text_home'),
      		'separator' => FALSE
   		);

   		$this->document->breadcrumbs[] = array(
       		'href'      => HTTPS_SERVER . 'index.php?route=extension/module&token=' . $this->session->data['token'],
       		'text'      => $this->language->get('text_module'),
      		'separator' => ' :: '
   		);
		
   		$this->document->breadcrumbs[] = array(
       		'href'      => HTTPS_SERVER . 'index.php?route=module/news&token=' . $this->session->data['token'],
       		'text'      => $this->language->get('heading_title'),
      		'separator' => ' :: '
   		);
		
		$this->data['action'] = HTTPS_SERVER . 'index.php?route=module/news&token=' . $this->session->data['token'];
		
		$this->data['cancel'] = HTTPS_SERVER . 'index.php?route=extension/module&token=' . $this->session->data['token'];

		$this->load->model('catalog/newscate');
		
		$this->data['categories'] = array();
		
		$results = $this->model_catalog_newscate->getCate4DefaultStore(0);
		
		foreach ($results as $result) {
			$this->data['categories'][] = array(
				'news_category_id' => $result['news_category_id'],
				'name'        => $result['name'],
				'sort_order'  => $result['sort_order']
			);
		}
		
		if (isset($this->request->post['news_categories'])) {
			$this->data['news_category'] = $this->request->post['news_categories'];
		} else {
			$this->data['news_category'] = explode(',',$this->config->get('news_categories')) ;
		}
		
		if (isset($this->request->post['news_position'])) {
			$this->data['news_position'] = $this->request->post['news_position'];
		} else {
			$this->data['news_position'] = $this->config->get('news_position');
		}
		
		if (isset($this->request->post['news_status'])) {
			$this->data['news_status'] = $this->request->post['news_status'];
		} else {
			$this->data['news_status'] = $this->config->get('news_status');
		}
		
		if (isset($this->request->post['news_col'])) {
			$this->data['news_col'] = $this->request->post['news_col'];
		} else {
			$this->data['news_col'] = $this->config->get('news_col');
		}
		
		if (isset($this->request->post['news_limited'])) {
			$this->data['news_limited'] = $this->request->post['news_limited'];
		} else {
			$this->data['news_limited'] = $this->config->get('news_limited');
		}
		
		if (isset($this->request->post['news_page'])) {
			$this->data['news_page'] = $this->request->post['news_page'];
		} else {
			$this->data['news_page'] = $this->config->get('news_page');
		}
		
		if (isset($this->request->post['news_sort_order'])) {
			$this->data['news_sort_order'] = $this->request->post['news_sort_order'];
		} else {
			$this->data['news_sort_order'] = $this->config->get('news_sort_order');
		}				
		
		$this->template = 'module/news.tpl';
		$this->children = array(
			'common/header',	
			'common/footer'	
		);
		
		$this->response->setOutput($this->render(TRUE), $this->config->get('config_compression'));
	}
	
	private function validate() {
		if (!$this->user->hasPermission('modify', 'module/news')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
	
		if (!$this->error) {
			return TRUE;
		} else {
			return FALSE;
		}	
	}
}
?>