<?php
class ModelCatalogNews extends Model {
	public function addNews($data) {
		foreach ($data['news'] as $language_id => $value) {
			$this->db->query("INSERT INTO " . DB_PREFIX . "news SET language_id = '" . (int)$language_id . "',status = '" . (int)$data['status'] . "', title = '" . $this->db->escape($value['title']) . "', meta_keywords = '" . $this->db->escape($value['meta_keywords']) . "',sort_order = '" . (int)$data['sort_order'] . "', content = '" . $this->db->escape($value['content']) . "' , date_modified = NOW(), date_added = NOW() ");
		}

		$news_id = $this->db->getLastId();
		
		if (isset($data['news_category'])) {
			foreach ($data['news_category'] as $news_category_id) {
				$this->db->query("INSERT INTO " . DB_PREFIX . "news_to_category SET news_id = '" . (int)$news_id . "', news_category_id = '" . (int)$news_category_id . "'");
				if ($data['keyword']) {
				$this->db->query("INSERT INTO " . DB_PREFIX . "url_alias SET query = 'news_id=" . (int)$news_id . "&category_id=".(int)$news_category_id  ."', keyword = '" . $this->db->escape($data['keyword']) . "'");
		}
			}
		}
		
		
		
		foreach ($data['news_tags'] as $language_id => $value) {
			$tags = explode(',', $value);
			foreach ($tags as $tag) {
				$this->db->query("INSERT INTO " . DB_PREFIX . "news_tags SET news_id = '" . (int)$news_id . "', language_id = '" . (int)$language_id . "', tag = '" . $this->db->escape(trim($tag)) . "'");
			}
		}
		
		if (isset($data['news_related'])) {
			foreach ($data['news_related'] as $related_id) {
				$this->db->query("INSERT INTO " . DB_PREFIX . "news_related SET news_id = '" . (int)$news_id . "', related_id = '" . (int)$related_id . "'");
				$this->db->query("INSERT INTO " . DB_PREFIX . "news_related SET news_id = '" . (int)$related_id . "', related_id = '" . (int)$news_id . "'");
			}
		}
		
		$this->cache->delete('news');
	}
	
	public function editNews($news_id, $data) {
		$this->db->query("DELETE FROM " . DB_PREFIX . "news WHERE news_id = '" . (int)$news_id . "'");
		
		foreach ($data['news'] as $language_id => $value) {
			$this->db->query("INSERT INTO " . DB_PREFIX . "news SET news_id = '" . (int)$news_id . "' , language_id = '" . (int)$language_id . "',status = '" . (int)$data['status'] . "', title = '" . $this->db->escape($value['title']) . "', meta_keywords = '" . $this->db->escape($value['meta_keywords']) . "',sort_order = '" . (int)$data['sort_order'] . "',  content = '" . $this->db->escape($value['content']) . "' , date_modified = NOW(), date_added = NOW()  ");
		}
	
		$this->db->query("DELETE FROM " . DB_PREFIX . "news_to_category WHERE  news_id = '" . (int)$news_id . "'");
		
		if (isset($data['news_category'])) {
			foreach ($data['news_category'] as $news_category_id) {
				$this->db->query("INSERT INTO " . DB_PREFIX . "news_to_category SET news_id = '" . (int)$news_id . "', news_category_id = '" . (int)$news_category_id . "'");
			}
			$this->db->query("DELETE FROM " . DB_PREFIX . "url_alias WHERE query = 'news_id=" . (int)$news_id. "'");
		
			if ($data['keyword']) {
				$this->db->query("INSERT INTO " . DB_PREFIX . "url_alias SET query = 'news_id=" . (int)$news_id . "&category_id=".(int)$news_category_id . "', keyword = '" . $this->db->escape($data['keyword']) . "'");
			}
			
		}

		
		
		$this->db->query("DELETE FROM " . DB_PREFIX . "news_tags WHERE news_id = '" . (int)$news_id. "'");
		
		foreach ($data['news_tags'] as $language_id => $value) {
			$tags = explode(',', $value);
			foreach ($tags as $tag) {
				$this->db->query("INSERT INTO " . DB_PREFIX . "news_tags SET news_id = '" . (int)$news_id . "', language_id = '" . (int)$language_id . "', tag = '" . $this->db->escape(trim($tag)) . "'");
			}
		}
		
		$this->db->query("DELETE FROM " . DB_PREFIX . "news_related WHERE news_id = '" . (int)$news_id . "'");
		
		if (isset($data['news_related'])) {
			foreach ($data['news_related'] as $related_id) {
				$this->db->query("INSERT INTO " . DB_PREFIX . "news_related SET news_id = '" . (int)$news_id . "', related_id = '" . (int)$related_id . "'");
				$this->db->query("DELETE FROM " . DB_PREFIX . "news_related WHERE news_id = '" . (int)$related_id . "' AND related_id = '" . (int)$news_id . "'");
				$this->db->query("INSERT INTO " . DB_PREFIX . "news_related SET news_id = '" . (int)$related_id . "', related_id = '" . (int)$news_id . "'");
			}
		}
		
		$this->cache->delete('news');
	}
	
	public function deleteNews($news_id) {
		$this->db->query("DELETE FROM " . DB_PREFIX . "news WHERE news_id = '" . (int)$news_id . "'");
		$this->db->query("DELETE FROM " . DB_PREFIX . "news_to_category WHERE news_id = '" . (int)$news_id . "'");
		$this->db->query("DELETE FROM " . DB_PREFIX . "url_alias WHERE query = 'news_id=" . (int)$news_id. "'");
		$this->db->query("DELETE FROM " . DB_PREFIX . "news_tags WHERE news_id='" . (int)$news_id. "'");
		$this->db->query("DELETE FROM " . DB_PREFIX . "news_related WHERE news_id='" . (int)$news_id. "'");
		$this->cache->delete('news');
	}
	
	public function getOneNews($news_id) {
		$query = $this->db->query("SELECT DISTINCT *, (SELECT keyword FROM " . DB_PREFIX . "url_alias WHERE query = 'news_id=" . (int)$news_id . "') AS keyword FROM  " . DB_PREFIX . "news p WHERE p.news_id = '" . (int)$news_id . "' AND p.language_id = '" . (int)$this->config->get('config_language_id') . "'");
				
		return $query->row;
	}
	
	public function getNews($data = array()) {
		if ($data) {
			$sql = "SELECT pd.* FROM   " . DB_PREFIX . "news  pd WHERE pd.language_id = '" . (int)$this->config->get('config_language_id') . "'"; 
		if (isset($data['filter_title']) && !is_null($data['filter_title'])) {
				$sql .= " AND LCASE(pd.title) LIKE '%" . $this->db->escape(strtolower($data['filter_title'])) . "%'";
			}

			if (isset($data['filter_status']) && !is_null($data['filter_status'])) {
				$sql .= " AND pd.status = '" . (int)$data['filter_status'] . "'";
			}

			$sort_data = array(
				'pd.title',
				'pd.status',
				'pd.sort_order'
			);	
			
			if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
				$sql .= " ORDER BY " . $data['sort'];	
			} else {
				$sql .= " ORDER BY pd.title";	
			}
			
			if (isset($data['order']) && ($data['order'] == 'DESC')) {
				$sql .= " DESC";
			} else {
				$sql .= " ASC";
			}
		
			if (isset($data['start']) || isset($data['limit'])) {
				if ($data['start'] < 0) {
					$data['start'] = 0;
				}				

				if ($data['limit'] < 1) {
					$data['limit'] = 20;
				}	
			
				$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
			}	
			
			$query = $this->db->query($sql);
		
			return $query->rows;
		} else {
			$news_data = $this->cache->get('news.' . $this->config->get('config_language_id'));
		
			if (!$news_data) {
				$query = $this->db->query("SELECT pd.* FROM  " . DB_PREFIX . "news pd   WHERE pd.language_id = '" . (int)$this->config->get('config_language_id') . "' ORDER BY pd.title ASC");
	
				$news_data = $query->rows;
			
				$this->cache->set('news.' . $this->config->get('config_language_id'), $news_data);
			}	
	
			return $news_data;
		}
	}


	public function getNewsByKeyword($keyword) {
		if ($keyword) {
			$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "news p WHERE p.language_id = '" . (int)$this->config->get('config_language_id') . "' AND (LCASE(p.title) LIKE '%" . $this->db->escape(strtolower($keyword)) . "%' )");
									  
			return $query->rows;
		} else {
			return array();	
		}		
	} 
	
	public function getNewsByCategoryId($category_id) {
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "news p LEFT JOIN " . DB_PREFIX . "news_to_category p2c ON (p.news_id = p2c.news_id) WHERE p.language_id = '" . (int)$this->config->get('config_language_id') . "' AND p2c.news_category_id = '" . (int)$category_id . "' ORDER BY p.title ASC");
								  
		return $query->rows;
	} 
	
	public function getNewsContent($news_id) {
		$news_data = array();
		
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "news WHERE news_id = '" . (int)$news_id . "'");
		
		foreach ($query->rows as $result) {
			$news_data[$result['language_id']] = array(
				'title'             => $result['title'],
				'meta_keywords'    => $result['meta_keywords'],
				'meta_description' => $result['meta_description'],
				'content'      => $result['content']
			);
		}
		
		return $news_data;
	}

	
	public function getNewsCategories($news_id) {
		$news_category_data = array();
		
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "news_to_category WHERE news_id = '" . (int)$news_id . "'");
		
		foreach ($query->rows as $result) {
			$news_category_data[] = $result['news_category_id'];
		}

		return $news_category_data;
	}

	public function getNewsRelated($news_id) {
		$news_related_data = array();
		
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "news_related WHERE news_id = '" . (int)$news_id . "'");
		
		foreach ($query->rows as $result) {
			$news_related_data[] = $result['related_id'];
		}
		
		return $news_related_data;
	}
	
	public function getNewsTags($news_id) {
		$news_tag_data = array();
		
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "news_tags WHERE news_id = '" . (int)$news_id . "'");
		
		$tag_data = array();
		
		foreach ($query->rows as $result) {
			$tag_data[$result['language_id']][] = $result['tag'];
		}
		
		foreach ($tag_data as $language => $tags) {
			$news_tag_data[$language] = implode(',', $tags);
		}
		
		return $news_tag_data;
	}
	
	public function getTotalNews($data = array()) {
		$sql = "SELECT COUNT(*) AS total FROM " . DB_PREFIX . "news pd WHERE pd.language_id = '" . (int)$this->config->get('config_language_id') . "'";
		
		if (isset($data['filter_name']) && !is_null($data['filter_name'])) {
			$sql .= " AND LCASE(pd.name) LIKE '%" . $this->db->escape(strtolower($data['filter_name'])) . "%'";
		}

		if (isset($data['filter_status']) && !is_null($data['filter_status'])) {
			$sql .= " AND pd.status = '" . (int)$data['filter_status'] . "'";
		}

		$query = $this->db->query($sql);
		
		return $query->row['total'];
	}	
		
}
?>