<?php 
class ControllerInformationNews extends Controller {
	public function index() {  
    	$this->language->load('information/news');
		$this->load->model('catalog/news');
		$this->load->model('catalog/newscate');
		
		$this->document->breadcrumbs = array();
		$this->document->breadcrumbs[] = array(
        	'href'      => HTTP_SERVER . 'index.php?route=common/home',
        	'text'      => $this->language->get('text_home'),
        	'separator' => FALSE
      	);
		
		if (isset($this->request->get['category_id'])) {
			$category_id = $this->request->get['category_id'];
		} else {
			$category_id = 0;
		}
		
		if (isset($this->request->get['news_id'])) {
			$news_id = $this->request->get['news_id'];
		} else {
			$news_id = 0;
		}
		
		$category_info = $this->model_catalog_newscate->getCategoryDescriptions($category_id);
   		$result = $this->model_catalog_news->getOneNews($news_id);
	
		if(isset($result)){
			$this->data['title']=$result['title'];
			$this->data['date_added']= date('j-M-Y', strtotime($result['date_added']));
			$this->data['content']=html_entity_decode($result['content']);
			
			$this->data['heading_title'] =$category_info['name'];
			$this->document->title = $category_info['name'].'-'.$result['title'];
			$this->document->breadcrumbs[] = array(
        		'href'      => HTTP_SERVER . 'index.php?route=information/news/category&category_id=' . $this->request->get['category_id'],
        		'text'      => $category_info['name'],
        		'separator' => $this->language->get('text_separator')
      		);
			
			$this->data['button_continue'] = $this->language->get('button_continue');
			$this->data['continue'] = HTTP_SERVER . 'index.php?route=common/home';

			$relate_results = $this->model_catalog_news->getNewsRelated($news_id);
			$this->data['text_relate_news']=$this->language->get('text_relate_news');
			foreach ($relate_results as $relate_result) {
				$action = array();
				$news=$this->model_catalog_news->getOneNews($relate_result);
				if($news){
				$this->data['news'][] = array(
					'news_id'   => $news['news_id'],
					'title'     => $news['title'],
					'date_added'     => date('j-M-Y', strtotime($news['date_added'])),
					'href' 		=> HTTPS_SERVER . 'index.php?route=information/news&news_id=' . $news['news_id'].'&category_id=' .$this->request->get['category_id']
				);
				}
			}
			
			
			if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/information/news.tpl')) {
					$this->template = $this->config->get('config_template') . '/template/information/news.tpl';
			} else {
					$this->template = 'default/template/information/news.tpl';
			}
				
			$this->children = array(
					'common/column_right',
					'common/footer',
					'common/column_left',
					'common/header'
			);		
				
			$this->response->setOutput($this->render(TRUE), $this->config->get('config_compression'));
				
		}
		else {
      		$this->document->breadcrumbs[] = array(
        		'href'      => HTTP_SERVER . 'index.php?route=information/news/category&category_id=' . $this->request->get['category_id'],
        		'text'      => $this->language->get('text_error'),
        		'separator' => $this->language->get('text_separator')
      		);
				
	  		$this->document->title = $this->language->get('text_error');
			
      		$this->data['heading_title'] = $this->language->get('text_error');

      		$this->data['text_error'] = $this->language->get('text_error');

      		$this->data['button_continue'] = $this->language->get('button_continue');

      		$this->data['continue'] = HTTP_SERVER . 'index.php?route=common/home';

			if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/error/not_found.tpl')) {
				$this->template = $this->config->get('config_template') . '/template/error/not_found.tpl';
			} else {
				$this->template = 'default/template/error/not_found.tpl';
			}
			
			$this->children = array(
				'common/column_right',
				'common/footer',
				'common/column_left',
				'common/header'
			);
		
	  		$this->response->setOutput($this->render(TRUE), $this->config->get('config_compression'));
    	}
  	}
	
	public function category() {
		$this->language->load('information/news');
		
		$this->document->breadcrumbs = array();
		
      	$this->document->breadcrumbs[] = array(
        	'href'      => HTTP_SERVER . 'index.php?route=common/home',
        	'text'      => $this->language->get('text_home'),
        	'separator' => FALSE
      	);
		
		$this->data['button_continue'] = $this->language->get('button_continue');
	
		if (isset($this->request->get['category_id'])) {
			$category_id = $this->request->get['category_id'];
		} else {
			$category_id = 0;
		}      
		
		if (isset($this->request->get['page'])) {
			$page = $this->request->get['page'];
		} else {
			$page = 1;
		}  
		
		$limited =  $this->config->get('news_page');
		$this->load->model('catalog/newscate');
		$this->load->model('catalog/news');
		
		$data = array(
			'category_id'            => $category_id,
			'start'           => ($page - 1) * $limited,
			'limit'           => $limited
		);
		
		$category_info = $this->model_catalog_newscate->getCategoryDescriptions($category_id);
		
		$this->data['no_record_found']=$this->language->get('text_no_record');
		
		if(isset($category_info)){
			$this->data['category']=$category_info['name'];
			$this->data['heading_title'] = $category_info['name'];
			$this->document->title = $category_info['name']; 
			$this->document->breadcrumbs[] = array(
        		'href'      => HTTP_SERVER . 'index.php?route=information/news/category&category_id=' . $this->request->get['category_id'],
        		'text'      => $category_info['name'],
        		'separator' => $this->language->get('text_separator')
      		);
			
			$results = $this->model_catalog_news->getNews($data);
			$total = $this->model_catalog_news->getTotalNewsByCategoryId($category_id);
			
			foreach ($results as $result) {
				$action = array();
				
				$this->data['news'][] = array(
					'news_id'   => $result['news_id'],
					'title'     => $result['title'],
					'date_added'     => date('j-M-Y', strtotime($result['date_added'])),
					'href' 		=> HTTPS_SERVER . 'index.php?route=information/news&news_id=' . $result['news_id'].'&category_id=' .$category_id
				);
			}
			
			$pagination = new Pagination();
			$pagination->total = $total;
			$pagination->page = $page;
			$pagination->limit = $limited;
			$pagination->text = $this->language->get('text_pagination');
			$pagination->url = HTTPS_SERVER . 'index.php?route=information/news/category&category_id=' . $this->request->get['category_id'].'&page={page}';
				
			$this->data['pagination'] = $pagination->render();
			$this->data['button_continue'] = $this->language->get('button_continue');
			$this->data['continue'] = HTTP_SERVER . 'index.php?route=common/home';

			if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/information/news_list.tpl')) {
					$this->template = $this->config->get('config_template') . '/template/information/news_list.tpl';
			} else {
					$this->template = 'default/template/information/news_list.tpl';
			}
				
			$this->children = array(
					'common/column_right',
					'common/footer',
					'common/column_left',
					'common/header'
			);		
				
			$this->response->setOutput($this->render(TRUE), $this->config->get('config_compression'));
				
		}
		else {
      		$this->document->breadcrumbs[] = array(
        		'href'      => HTTP_SERVER . 'index.php?route=information/news/category&category_id=' . $this->request->get['category_id'],
        		'text'      => $this->language->get('text_error'),
        		'separator' => $this->language->get('text_separator')
      		);
				
	  		$this->document->title = $this->language->get('text_error');
			
      		$this->data['heading_title'] = $this->language->get('text_error');

      		$this->data['text_error'] = $this->language->get('text_error');

      		$this->data['button_continue'] = $this->language->get('button_continue');

      		$this->data['continue'] = HTTP_SERVER . 'index.php?route=common/home';

			if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/error/not_found.tpl')) {
				$this->template = $this->config->get('config_template') . '/template/error/not_found.tpl';
			} else {
				$this->template = 'default/template/error/not_found.tpl';
			}
			
			$this->children = array(
				'common/column_right',
				'common/footer',
				'common/column_left',
				'common/header'
			);
		
	  		$this->response->setOutput($this->render(TRUE), $this->config->get('config_compression'));
    	}
	}
}
?>