<?php
class ModelCatalogNews extends Model {
	
	public function getOneNews($news_id) {
		$query = $this->db->query("SELECT DISTINCT *, (SELECT keyword FROM " . DB_PREFIX . "url_alias WHERE query = 'news_id=" . (int)$news_id . "') AS keyword FROM  " . DB_PREFIX . "news p WHERE p.status=1 AND p.news_id = '" . (int)$news_id . "' AND p.language_id = '" . (int)$this->config->get('config_language_id') . "'");
				
		return $query->row;
	}
	
	public function getNews($data = array()) {
		$sql = "SELECT pd.* FROM   " . DB_PREFIX . "news  pd LEFT JOIN " . DB_PREFIX . "news_to_category p2c ON (pd.news_id = p2c.news_id) WHERE pd.language_id = '" . (int)$this->config->get('config_language_id') . "'
		 AND pd.status=1 AND p2c.news_category_id = '" . (int)$data['category_id']  . "'
		"; 
		if (isset($data['title']) && !is_null($data['title'])) {
				$sql .= " AND LCASE(pd.title) LIKE '%" . $this->db->escape(strtolower($data['filter_title'])) . "%'";
			}

			if (isset($data['filter_status']) && !is_null($data['filter_status'])) {
				$sql .= " AND pd.status = '" . (int)$data['filter_status'] . "'";
			}

			$sort_data = array(
				'pd.title',
				'pd.status',
				'pd.sort_order'
			);	
			
			if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
				$sql .= " ORDER BY " . $data['sort'];	
			} else {
				$sql .= " ORDER BY pd.title";	
			}
			
			if (isset($data['order']) && ($data['order'] == 'DESC')) {
				$sql .= " DESC";
			} else {
				$sql .= " ASC";
			}
		
			if (isset($data['start']) || isset($data['limit'])) {
				if ($data['start'] < 0) {
					$data['start'] = 0;
				}				

				if ($data['limit'] < 1) {
					$data['limit'] = 20;
				}	
			
				$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
			}	
			
			$query = $this->db->query($sql);
		
			return $query->rows;
	}


	public function getNewsByKeyword($keyword) {
		if ($keyword) {
			$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "news p WHERE p.status=1 AND  p.language_id = '" . (int)$this->config->get('config_language_id') . "' AND (LCASE(p.title) LIKE '%" . $this->db->escape(strtolower($keyword)) . "%' )");
									  
			return $query->rows;
		} else {
			return array();	
		}		
	} 
	
	public function getNewsByCategoryId($category_id) {
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "news p LEFT JOIN " . DB_PREFIX . "news_to_category p2c ON (p.news_id = p2c.news_id) WHERE p.status=1 AND  p.language_id = '" . (int)$this->config->get('config_language_id') . "' AND p2c.news_category_id = '" . (int)$category_id . "' ORDER BY p.date_modified DESC ,p.title ASC");
								  
		return $query->rows;
	} 
	
	public function getTotalNewsByCategoryId($category_id) {
		$query = $this->db->query("SELECT count(*) as total FROM " . DB_PREFIX . "news p LEFT JOIN " . DB_PREFIX . "news_to_category p2c ON (p.news_id = p2c.news_id) WHERE p.status=1 AND  p.language_id = '" . (int)$this->config->get('config_language_id') . "' AND p2c.news_category_id = '" . (int)$category_id . "' ORDER BY p.title ASC");
	  
		return $query->row['total'];
	} 
	
	public function getNewsContent($news_id) {
		$news_data = array();
		
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "news WHERE p.status=1 AND  news_id = '" . (int)$news_id . "'");
		
		foreach ($query->rows as $result) {
			$news_data[$result['language_id']] = array(
				'title'             => $result['title'],
				'meta_keywords'    => $result['meta_keywords'],
				'meta_description' => $result['meta_description'],
				'content'      => $result['content']
			);
		}
		
		return $news_data;
	}

	
	public function getNewsCategories($news_id) {
		$news_category_data = array();
		
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "news_to_category WHERE news_id = '" . (int)$news_id . "'");
		
		foreach ($query->rows as $result) {
			$news_category_data[] = $result['news_category_id'];
		}

		return $news_category_data;
	}

	public function getNewsRelated($news_id) {
		$news_related_data = array();
		
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "news_related WHERE news_id = '" . (int)$news_id . "'");
		
		foreach ($query->rows as $result) {
			$news_related_data[] = $result['related_id'];
		}
		
		return $news_related_data;
	}
	
	public function getNewsTags($news_id) {
		$news_tag_data = array();
		
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "news_tags WHERE news_id = '" . (int)$news_id . "'");
		
		$tag_data = array();
		
		foreach ($query->rows as $result) {
			$tag_data[$result['language_id']][] = $result['tag'];
		}
		
		foreach ($tag_data as $language => $tags) {
			$news_tag_data[$language] = implode(',', $tags);
		}
		
		return $news_tag_data;
	}
	
	public function getTotalNews($data = array()) {
		$sql = "SELECT COUNT(*) AS total FROM " . DB_PREFIX . "news pd WHERE  pd.status=1 AND  pd.language_id = '" . (int)$this->config->get('config_language_id') . "'";
		
		if (isset($data['filter_name']) && !is_null($data['filter_name'])) {
			$sql .= " AND LCASE(pd.name) LIKE '%" . $this->db->escape(strtolower($data['filter_name'])) . "%'";
		}

		if (isset($data['filter_status']) && !is_null($data['filter_status'])) {
			$sql .= " AND pd.status = '" . (int)$data['filter_status'] . "'";
		}

		$query = $this->db->query($sql);
		
		return $query->row['total'];
	}	
		
}
?>